<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Hallazgos</strong>
    </div>
    <!-- <div class="cotm">
      <div class="tmod">
        <strong>Consulta la información de tus sucursales</strong>
      </div>
    </div>-->
    <!-- Contenido -->
    <div class="contSecc">
      <div class="titSecCard">Búsqueda</div>
      <v-card style="background-color: #fafafa;">
        <v-container fluid>
          <div class="indicaciones">
            Consulta la información de tus sucursales, completa los campos por
            los que deseas buscar.
          </div>
          <v-row align="center">
            <!-- CECO / SUCURSAL -->
            <v-col cols="4">
              <div class="titCampos">Sucursal</div>
              <v-autocomplete
                outlined
                :items="metadata.cecos"
                item-value="ceco"
                item-text="ceco"
                dense
                hide-no-data
                placeholder="Busca una sucursal"
                append-icon
                :search-input.sync="textoIngresado"
                @keyup="actualizaCecos"
                @change="llenaSelect"
                return-object
                v-model="cecoSeleccionado"
              ></v-autocomplete>
            </v-col>
            <!-- TIPO VISITA -->
            <v-col cols="4">
              <div class="titCampos">Tipo de recorrido</div>
              <v-select
                v-model="selected"
                :value="''"
                :items="metadata.tiposRecorrido"
                placeholder="Selecciona un tipo de recorrido"
                dense
                outlined
                @click="getSeleccionado()"
              ></v-select>
            </v-col>

            <v-col>
              <!-- BUSCAR -->
              <v-col>
                <v-btn block color="primary" @click="getInfoSucursal" dark>
                  <strong style="font-size: 16px; color: #000;">Buscar</strong>
                </v-btn>
              </v-col>
            </v-col>
          </v-row>

          <v-row align="center"></v-row>
          <br />
        </v-container>
      </v-card>
      <br />
      <!-- TABLA -->
      <div class="titSecCard" v-show="infoSucursalResult">
        Resultados de búsqueda
      </div>
      <v-card
        id="tablaResultados"
        v-show="infoSucursalResult"
        style="background-color: #fafafa;"
      >
        <v-card-title>
          <v-spacer></v-spacer>
          <v-col cols="4">
            <v-text-field
              outlined
              v-model="search"
              append-icon="mdi-magnify"
              placeholder="Buscar..."
              single-line
              dense
              hide-details
            ></v-text-field>
          </v-col>
        </v-card-title>
        <v-data-table
          :headers="encabezados"
          :items="datosSucursal"
          :search="search"
          class="tabla"
        >
          <template v-slot:item="row">
            <!-- <tr @click="getHallazgos(row.item)"> -->
            <tr @click="goToHallazgos(row.item)">
              <td align="center">{{ row.item.nombreCeco }}</td>
              <td align="center">{{ row.item.ceco }}</td>
              <td align="center">{{ row.item.zona }}</td>
              <td align="center">{{ row.item.region }}</td>
              <td align="center">{{ row.item.idRecorrido }}</td>
              <!--<td align="center">{{getNomRecorrido(row.item.idRecorrido)}}</td>-->
              <td align="center">{{ row.item.perido }}</td>
              <td align="center">
                <a
                  class="liga"
                  @click="goToHallazgos(row.item)"
                  block
                  style="color: #2d2926"
                  >Ver hallazgos</a
                >
              </td>
            </tr>
          </template>
        </v-data-table>
      </v-card>
    </div>
    <!-- Fin conSecc -->
  </div>
</template>
<style scoped></style>
<script>
import router from "@/router";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
const serviceCommons = store.state.serviceCommons;

export default {
  data() {
    return {
      menuInicio: false,
      menuFin: false,
      modal: false,
      cecoSeleccionado: "",
      nombreCecoSeleccionado: "",
      tipoRecorrido: "",
      fechaInicio: "",
      fechaFin: "",
      textoIngresado: "",
      infoSucursalResult: false,
      selected: "Todos",
      dataSucursalSave: "",
      metadata: {
        tiposRecorrido: [],
        cecos: [],
      },
      search: "",
      encabezados: [
        { text: "Sucursal", value: "nombreCeco", align: "center" },
        { text: "CECO", value: "ceco", align: "center" },
        { text: "Zona", value: "zona", align: "center" },
        { text: "Región", value: "region", align: "center" },
        { text: "Recorrido", value: "idRecorrido", align: "center" },
        { text: "Fecha", value: "perido", align: "center" },
        { text: "Hallazgos", value: "hallazgos", align: "center" },
      ],
      //datosSucursal: []
      datosSucursal: [
        {
          fase: null,
          proyecto: null,
          idCanal: null,
          hallazgos: null,
          historialHallazgos: null,
          dashboard: null,
          idBita: null,
          idResp: null,
          idArbol: null,
          observ: null,
          idPreg: null,
          idCheck: null,
          idPosible: null,
          idObserv: null,
          posible: null,
          pregunta: null,
          idcritica: null,
          idcheckUsua: null,
          idUsu: null,
          checklist: null,
          idOrdenGru: null,
          idperiodicidad: null,
          respuestaAbierta: null,
          idRespAb: null,
          banderaRespAb: null,
          modulo: null,
          precalif: null,
          clasif: null,
          calCheck: null,
          bitGral: null,
          fechaTermino: null,
          idRecorrido: null,
          ceco: null,
          nombreCeco: null,
          activoCeco: null,
          cecoSuperior: null,
          direccion: null,
          region: null,
          territorio: null,
          zona: null,
          aperturable: null,
          perido: null,
          aux: null,
          aux2: null,
          pregPadre: null,
          version: null,
          fechaIni: null,
          fechaFin: null,
          bita1: null,
          bita2: null,
          pregFilt: null,
          ruta: null,
          nomCeco: null,
          nomUsu: null,
          obs: null,
          pondTot: null,
          sumPreg: null,
          sum: null,
          listaImperdonables: null,
        },
      ],
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Modelo de Entrega",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_entrega",
          },
        },
        {
          text: "Busqueda Hallazgos",
          disabled: true,
          exact: true,
        },
      ],
    };
  },
  methods: {
    getCecos() {
      axiosChecklist
        .get(
          "/expansionCoreServices/getTipoRecorrido.json?ceco=" +
            this.textoIngresado
        )
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              this.metadata.cecos = response.data;
              this.tipoRecorrido = response.data[0].status;
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    actualizaCecos() {
      if (this.textoIngresado != null && this.textoIngresado.length > 2) {
        this.getCecos();
      } else if (this.textoIngresado == null || this.textoIngresado == "") {
        this.cecoSeleccionado = "";
        this.metadata.cecos = [];
        this.tipoRecorrido = "";
        this.metadata.tiposRecorrido = [];
        this.fechaInicio = "";
        this.fechaFin = "";
        this.nombreCecoSeleccionado = "";
        this.selected = "Todos";
      }
    },
    getInfoSucursal() {
      //alert("Entra getInfoSucursal");
      if (this.cecoSeleccionado != null) {
        var res = this.cecoSeleccionado.ceco.split(" - ");
        this.nombreCecoSeleccionado = res[0];
        let idCecoSeleccionado = res[1];
        //alert(idCecoSeleccionado);
        //alert(this.nombreCecoSeleccionado);
        if (this.selected === "Todos") {
          this.tipoRecorrido = "";
        }
        //alert("Tipo Recorrido: " + this.tipoRecorrido);

        if (this.metadata.tiposRecorrido)
          axiosChecklist
            .get(
              "/expansionCoreServices/getInfoRecorridos.json?idCeco=" +
                idCecoSeleccionado +
                "&nombreCeco=" +
                this.nombreCecoSeleccionado +
                "&tipoRecorrido=" +
                this.tipoRecorrido +
                "&fechaInicio=" +
                this.fechaInicio +
                "&fechaFin=" +
                this.fechaFin
            )
            .then((response) => {
              this.dataSucursalSave = this.cecoSeleccionado;
              if (response) {
                if (response.status === 200) {
                  console.log(response.data);
                  this.datosSucursal = response.data;
                  /*var i = 0;
                  for (i = 0; i < this.datosSucursal.length; i++) {
                    if (this.datosSucursal[i].idRecorrido === "1") {
                      this.datosSucursal[i].idRecorrido =
                        "Validación de Edificación Terminada";
                    } else if (this.datosSucursal[i].idRecorrido === "2") {
                      this.datosSucursal[i].idRecorrido = "Validación Técnica";
                    } else if (this.datosSucursal[i].idRecorrido === "3") {
                      this.datosSucursal[i].idRecorrido =
                        "Validación Recepción de Obra";
                    } else if (this.datosSucursal[i].idRecorrido === "4") {
                      this.datosSucursal[i].idRecorrido = "Validación Caminata";
                    } else if (this.datosSucursal[i].idRecorrido === "5") {
                      this.datosSucursal[i].idRecorrido = "Soft Opening";
                    }
                  }*/
                }
              }
            })
            .catch((error) => {
              console.log(error);
            })
            .finally(function() {});
      } else {
        alert("Necesitas Seleccionar un Ceco");
      }
      this.infoSucursalResult = true;
    },
    validaFecha() {
      if (this.fechaInicio != null) {
        var fi = new Date();
        var ff = new Date();

        var fechaInicial = this.fechaInicio.split("-");
        var fechaFinal = this.fechaFin.split("-");

        fi.setFullYear(fechaInicial[2], fechaInicial[1], fechaInicial[0]);
        ff.setFullYear(fechaFinal[2], fechaFinal[1], fechaFinal[0]);

        if (ff >= fi) {
          return true;
        } else {
          alert("LA FECHA FIN DEBE SER MAYOR A LA INICIAL");
          return false;
        }
      } else {
        alert("SIN FECHA INICIAL");
        this.fechaFin = null;
      }
    },
    llenaSelect() {
      var arr = new Array();
      if (
        this.metadata.cecos[0].idCanal === 28 ||
        this.metadata.cecos[0].idCanal === 25
      ) {
        arr[0] = "Todos";
        /*if (4 === this.tipoRecorrido) {
          arr[1] = "Validación Caminata";
          this.tipoRecorrido = this.tipoRecorrido - 3;
        } else if (5 === this.tipoRecorrido) {
          arr[1] = "Validación Caminata";
          arr[2] = "Soft Opening";
          this.tipoRecorrido = this.tipoRecorrido - 3;
        } else {
          arr = null;
        }*/
      } else {
        arr[0] = "Todos";
        /*if (1 === this.tipoRecorrido) {
          arr[1] = "Validación de Edificación Terminada";
        } else if (2 === this.tipoRecorrido) {
          arr[1] = "Validación de Edificación Terminada";
          arr[2] = "Validación Técnica";
        } else if (3 === this.tipoRecorrido) {
          arr[1] = "Validación de Edificación Terminada";
          arr[2] = "Validación Técnica";
          arr[3] = "Validación Recepción de Obra";
        } else if (4 === this.tipoRecorrido) {
          arr[1] = "Validación de Edificación Terminada";
          arr[2] = "Validación Técnica";
          arr[3] = "Validación Recepción de Obra";
          arr[4] = "Validación Caminata";
        } else if (5 === this.tipoRecorrido) {
          arr[1] = "Validación de Edificación Terminada";
          arr[2] = "Validación Técnica";
          arr[3] = "Validación Recepción de Obra";
          arr[4] = "Validación Caminata";
          arr[5] = "Soft Opening";
        } else {
          arr = null;
        }*/
      }
      this.metadata.tiposRecorrido = arr;
    },
    getSeleccionado() {
      //alert(this.metadata.cecos[0].idCanal);
      if (
        this.metadata.cecos[0].idCanal === 28 ||
        this.metadata.cecos[0].idCanal === 25
      ) {
        //alert("If");
        if (this.selected === "Validación Caminata") {
          this.tipoRecorrido = 1;
        } else if (this.selected === "Soft Opening") {
          this.tipoRecorrido = 2;
        }
      } else {
        //alert("Else");
        if (this.selected === "Validación de Edificación Terminada") {
          this.tipoRecorrido = 1;
        } else if (this.selected === "Validación Técnica") {
          this.tipoRecorrido = 2;
        } else if (this.selected === "Validación Recepción de Obra") {
          this.tipoRecorrido = 3;
        } else if (this.selected === "Validación Caminata") {
          this.tipoRecorrido = 4;
        } else if (this.selected === "Soft Opening") {
          this.tipoRecorrido = 5;
        }
      }
      //alert(this.tipoRecorrido);
    },
    getNomRecorrido(idRecorrido) {
      //alert(idRecorrido);
      var cadena = "";
      if (idRecorrido.value === 1) {
        cadena = "Validación de Edificación Terminada";
      } else if (idRecorrido.value === 2) {
        cadena = "Validación Técnica";
      } else if (idRecorrido.value === 3) {
        cadena = "Validación Recepción de Obra";
      } else if (idRecorrido.value === 4) {
        cadena = "Validación Caminata";
      } else if (idRecorrido.value === 5) {
        cadena = "Soft Opening";
      }
      //alert(cadena);
      return cadena;
    },
    goToHallazgos(item) {
      var dataTransfer = {
        idProyecto: item.proyecto,
        idFase: item.fase,
        idCeco: item.ceco,
        nombreCecoIni: item.nombreCeco,
        numCecoIni: item.ceco,
        origenAtencion: false,
        fase: item.idRecorrido,
        territorio: item.territorio,
        zona: item.zona,
        region: item.region,
      };
      router.push({
        name: "modelo_franquicia_lista_hallazgos",
        params: {
          cecoFaseProyecto: serviceCommons.objectToBase64(dataTransfer),
        },
      });
    },
    getHallazgos(item) {
      //alert("Hallazgo: " + item.ceco + ", " + item.fase + ", " + item.proyecto);
      axiosChecklist
        .get(
          "expansionCoreServices/getHallazgosExpansionCore.json?ceco=" +
            item.ceco +
            "&proyecto=" +
            item.proyecto +
            "&fase=" +
            item.fase,
          {
            responseType: "json",
          }
        )
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              console.log(JSON.stringify(response.data));

              var dataTransfer = {
                data: response.data,
                idProyecto: item.proyecto,
                idFase: item.fase,
                idCeco: item.ceco,
                nombreCecoIni: item.nombreCeco,
                numCecoIni: item.ceco,
              };

              router.push({
                name: "modelo_franquicia_lista_hallazgos",
                params: {
                  cecoFaseProyecto: serviceCommons.objectToBase64(dataTransfer),
                },
              });
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
  },
  created() {},
  mounted() {
    if (localStorage.webVarStorage) {
      this.dataSucursalSave = localStorage.webVarStorage;
      this.cecoSeleccionado = this.dataSucursalSave;
    }
  },
  watch: {
    dataSucursalSave(param) {
      localStorage.webVarStorage = param;
      this.cecoSeleccionado = this.dataSucursalSave;
      this.getInfoSucursal();
    },
  },
};
</script>
